/**
 * File: UpdateLogin.java
 * Author: Ken-Yinn Chung, Edision Chindrawaly
 * Date: 2.17.2001
 */

import java.sql.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class UpdateLogin extends HttpServlet {
    Connection dbConn;

    // Make connection to database
    public void init() throws ServletException {
	String driver = "org.gjt.mm.mysql.Driver";
	String url = "jdbc:mysql://richese.csci.unt.edu/chung";
	String user = "chung";
	String pwd = "chung";

	try{
	    Class.forName(driver);
	    dbConn = DriverManager.getConnection(url, user, pwd);
	} catch(ClassNotFoundException e) {
	    System.out.println("Database driver class not found.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "JDBC driver class not found");
	} catch(SQLException e) {
	    System.out.println("Error connecting to the database.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "Cannot connect to the database");
	}
    } // end init


    private void createForm(PrintWriter out, Vector member, Vector contact) 
	throws ArrayIndexOutOfBoundsException {
	out.println("<HTML>\n" +
		    "<HEAD>\n" +
		    "  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		    "  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		    "VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n" +
		    "  <TITLE>Info update form</TITLE>\n" +
		    "</HEAD>\n"); 

	out.println("<BODY>\n\n" +
		    "<FORM METHOD=\"POST\" ACTION=\"Update\">\n");

	out.println("<TABLE>\n" +
		    "<TR>\n" +
		    "  <TD>First Name:</TD>" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"firstName\" " +
		    "VALUE=\"" + (String) member.get(1) + "\" SIZE=\"24\" " +
		    "MAXLENGTH=\"24\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD WIDTH=\"20%\">Last Name:</TD>" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"lastName\" " +
		    "VALUE=\"" + (String) member.get(0) + "\" SIZE=\"24\" " +
		    "MAXLENGTH=\"24\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Date of Birth:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"DOB\" VALUE=\"" +
		    (String) member.get(2) + "\" SIZE=\"10\" " +
		    "MAXLENGTH=\"10\"> " +
		    "<FONT SIZE=\"-2\" COLOR=\"DARKRED\">In yyyy-mm-dd " +
		    "format</FONT></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD HEIGHT=\"15\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Telephone:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"phone\" VALUE=\"" +
		    (String) contact.get(1) + "\" SIZE=\"20\" " +
		    "MAXLENGTH=\"20\">");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Street:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"street1\" VALUE=\"" +
		    (String) contact.get(2) + "\" SIZE=\"32\" " +
		    "MAXLENGTH=\"64\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
	// first name
		    "  <TD></TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"street2\" " +
		    "SIZE=\"32\" MAXLENGTH=\"64\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>City:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"city\" VALUE=\"" +
		    (String) contact.get(3) + "\" SIZE=\"32\" " +
		    "MAXLENGTH=\"32\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>State:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"state\" VALUE=\"" +
		    (String) contact.get(4) + "\" SIZE=\"25\" " +
		    "MAXLENGTH=\"32\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Zip Code:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"zip\" VALUE=\"" +
		    (String) contact.get(5) + "\" SIZE=\"16\" " +
		    "MAXLENGTH=\"16\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Country:</TD>\n" +
		    "  <TD><INPUT TEXT=\"TEXT\" NAME=\"country\" VALUE=\"" +
		    (String) contact.get(6) + "\" SIZE=\"32\" " +
		    "MAXLENGTH=\"48\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>E-mail Address:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"email\" VALUE=\"" +
		    (String) contact.get(0) + "\" SIZE=\"32\" " +
		    "MAXLENGTH=\"48\">&nbsp;&nbsp;" +
		    "<FONT SIZE=\"-2\" COLOR=\"DARKRED\">" +
		    "This will be your login ID</FONT></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Current Password:</TD>\n" +
		    "  <TD><INPUT TYPE=\"PASSWORD\" NAME=\"opassword\" " +
		    "VALUE=\"" + (String) member.get(6) + "\" SIZE=\"32\" " +
		    "MAXLENGTH=\"32\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>New Password:</TD>\n" +
		    "  <TD><INPUT TYPE=\"PASSWORD\" NAME=\"password\" " +
		    "SIZE=\"32\" MAXLENGTH=\"32\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Verify Password:</TD>\n" +
		    "  <TD><INPUT TYPE=\"PASSWORD\" NAME=\"vpassword\" " +
		    "SIZE=\"32\" MAXLENGTH=\"32\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD HEIGHT=\"15\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Degree:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"degType\" + VALUE=\"" +
		    (String) member.get(3) + "\" SIZE=\"24\" " +
		    "MAXLENGTH=\"32\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Major:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"major\" VALUE=\"" +
		    (String) member.get(4) + "\" SIZE=\"32\" " +
		    "MAXLENGTH=\"48\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD>Graduation Date:</TD>\n" +
		    "  <TD><INPUT TYPE=\"TEXT\" NAME=\"gradDate\" VALUE=\"" +
		    (String) member.get(5) + "\" SIZE=\"11\" "+
		    "MAXLENGTH=\"11\"><FONT SIZE=\"-2\" COLOR=\"DARKRED\">" +
		    "In <B>semester yyyy</B> format.  " +
		    "E.g. Spring 1999</FONT></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD HEIGHT=\"40\"><INPUT TYPE=\"HIDDEN\" " +
		    "NAME=\"loginEmail\" VALUE=\"" + (String) contact.get(0) +
		    "\"</TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "  <TD COLSPAN=\"2\"><INPUT TYPE=\"SUBMIT\" " +
		    "VALUE=\"Submit Changes\"></TD>");

	out.println("</TR><TR HEIGHT=\"35\">\n" +
		    "<TD COLSPAN=\"2\" HEIGHT=\"40\" VALIGN=\"BOTTOM\">" +
		    "|&nbsp<A HREF=\"../index.html\">Home</A>&nbsp|&nbsp" +
		    "<A HREF=\"../member_login.html\">Member Login</A>" +
		    "&nbsp|</TD>");

	out.println("</TR>\n" +
		    "</TABLE>\n" +
		    "</FONT>\n" +
		    "</FORM>\n");

	out.println("</BODY>\n" +
		    "</HTML>");

    } // end createForm


    public void doPost(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {

	ResultSet rs;
	Statement stmt;
	StringBuffer sql = new StringBuffer(512);
	PrintWriter out = response.getWriter();
	Vector missing = new Vector();
	Vector member = new Vector();
	Vector contact = new Vector();
	boolean user_found = false;
        String incorrectURL =
	    "http://jsp.csci.unt.edu/chung/incorrectLogin.html";
	int msize;
	int i;

	response.setContentType("text/html");

	// Login to modify user info
	// Get field values and check their validitions
	String login_email = request.getParameter("email");
	if (login_email.length() == 0)
	    missing.add("E-mail Address");

	String pwd = request.getParameter("password");
	if (pwd.length() == 0)
	    missing.add("Password");

	// Print error messages for missing entries
	if ((msize = missing.size()) > 0) {
	    for (i = 0; i < msize; i++) {
		out.println((String) missing.get(i) + " is missing.<P>");
	    } 

	    out.println("\nPlease press the BACK botton on your " +
			"browser to enter missing/invalid entries.");	    
	    return;
	}

	// Verify login member
	try {
	    stmt = dbConn.createStatement();

	    sql.append("SELECT email FROM member");
	    rs = stmt.executeQuery(sql.toString());
	    while (rs.next()) {
		if (rs.getString(1) != null &&
		    login_email.compareTo(rs.getString(1)) == 0) {
		    user_found = true;
		    break;
		}
	    }

	    if (!user_found) {
		//out.println("Invalid E-mail address.<P>Please press BACK " +
		//	    "button to try again.");
                response.sendRedirect(response.encodeURL(incorrectURL));
	    }

	    sql.delete(0, sql.length());
	    sql.append("SELECT password FROM member " +
		       "WHERE email=\"" + login_email + "\"");
	    rs = stmt.executeQuery(sql.toString());

	    if (rs.getString(1) != null &&
		pwd.compareTo(rs.getString(1)) == 0) {
		sql.delete(0, sql.length());
		sql.append("SELECT * FROM member " +
			   "WHERE email=\"" + login_email + "\"");
		rs = stmt.executeQuery(sql.toString());
		for (i = 1; i <= 8; i++)
		    member.add(rs.getString(i));

		sql.delete(0, sql.length());
		sql.append("SELECT * FROM contact " +
			   "WHERE email=\"" + login_email + "\"");
		rs = stmt.executeQuery(sql.toString());
		for (i = 1; i <= 7; i++)
		    contact.add(rs.getString(i));

		createForm(out, member, contact);
	    }
	    else {
                response.sendRedirect(response.encodeURL(incorrectURL));
	    }
	} catch (SQLException e) {
	    response.sendError(response.SC_ACCEPTED, "The request has been " +
			       "accepted, but it failed to complete due to " +
			       "an error querying the database.");
	    out.println(e);
	    return;
	}
    }

    public void destroy() {
	try {
	    dbConn.close();
	} catch (Exception e) {
	    System.out.println("Database close failed.");
	    System.out.println(e);
	}
    } // end destroy
}
