public class Item implements interfaceItem
{
 private String description; //description of the item
 private String type; // type of the Item(i.e. fd1,hd1,etc)
 private Float price;
 private int quantity;

 public final static Item NO_SUCH_ITEM = new Item();

 public Item()
 { }

 public Item(String typeItem, String descItem,float price)
 {
   setItem(typeItem,descItem,price);
 }


 public void setItem(String typeItem, String descItem, float price)
 {
   setType(typeItem);
   setDescription(descItem);
   setPrice(price);
 }

 public String getType()
 {
   return type;
 }

 public String getDescription()
 {
   return description;
 }

 public float getPrice()
 {
   return price.floatValue();
 }

 public int getQuantity()
 {
   return quantity;
 }

 public void setQuantity(int qty)
 {
  this.quantity = qty;
 }

 public void setType(String typeItem)
 {
   type = typeItem;
 }

 public void setDescription(String desc)
 {
   description = desc;
 }

 public void setPrice(float price)
 {
   this.price = new Float(price);
 }
}
