
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class UserLogin extends HttpServlet
{
 private ConnectionPool connPool;
 private int MAXSIZE=512;

 protected int initialConnection()
 {
  return(10);
 }

 protected int maxConnections()
 {
  return(50);
 }

 public void init() throws ServletException
 {
  String driver="org.gjt.mm.mysql.Driver";
  String url="jdbc:mysql://richese.csci.unt.edu/chung";
  String user="chung";
  String pwd="chung";
  try
  {
   connPool=new ConnectionPool(driver,url,user,pwd,
                               initialConnection(),
                               maxConnections(),
                               true); 
  }
  catch(SQLException sqle)
  {
   System.err.println("Error making pool:"+sqle);
   getServletContext().log("Error making pool:"+sqle);
   connPool = null;   
  }
 }

 public void destroy()
 {
  connPool.closeAllConnections();
 }

 public void doGet(HttpServletRequest request,
                   HttpServletResponse response)
                   throws ServletException, IOException
 {
  doPost(request,response);
 } 

 public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
                    throws ServletException, IOException
 { 
  ResultSet rs;
  Statement stmt;
  boolean errorFlag = false;
  PrintWriter out = response.getWriter();
  StringBuffer sql = new StringBuffer(MAXSIZE);
  StringBuffer tempUser = new StringBuffer(MAXSIZE);

  response.setContentType("text/html");

  String emailAddr = request.getParameter("emailAdd");
  String password  = request.getParameter("pwd");

  String wrongURL ="http://jsp.csci.unt.edu/chung/wrong.html"; 
  String nextURL = "http://jsp.csci.unt.edu/chung/jsp/user_menu.jsp?email=";
  String adminURL = "http://jsp.csci.unt.edu/chung/jsp/admin_menu.jsp?" +
      "email=sysAdmin@cs.unt.edu";
  String encodedURL;

  if(emailAddr.length() < 1)
  {
    out.println("<P>Need to input email address</p>\n");
    errorFlag = true;
  }
  if(password.length() < 1)
  {
    out.println("<P>Need to input password</P>\n");
    errorFlag = true;
  }
  if(errorFlag)
  {
    out.println("<p>Press the BACK botton on your browser and" +
                " re-enter the missing fields or reconfirm the"+ 
                " password</p>");
    return;
  }

  if (emailAddr.compareToIgnoreCase("sysAdmin@cs.unt.edu") == 0 &&
      password.compareTo("system administration") == 0)
  {
    HttpSession session = request.getSession(true);
    session.putValue("user_session", "System Administrator");
    response.sendRedirect(response.encodeURL(adminURL));
  }
  else
  {
    try
    {
      Connection connection = connPool.getConnection();
      sql.append("SELECT name, email, password " +
		 "FROM myuser " +
		 "WHERE email=\"" + emailAddr + "\"");
      stmt = connection.createStatement();   
      rs = stmt.executeQuery(sql.toString());
      if (rs.next())
      {
        if(rs.getString(2).compareToIgnoreCase(emailAddr) == 0 &&
	   rs.getString(3).compareTo(password) == 0) 
        {
	  String userName = rs.getString(1);

	  HttpSession session = request.getSession(true);
	  session.putValue("user_session", userName);
	  nextURL += emailAddr;
	  response.sendRedirect(response.encodeURL(nextURL));
	}
	else
	{
	  response.sendRedirect(response.encodeURL(wrongURL));
	}
      } // end if (rs.next())
      else
      {
	response.sendRedirect(response.encodeURL(wrongURL));
      }
    } // end try-block
    catch(SQLException e)
    {
      response.sendError(response.SC_ACCEPTED, "The request has been " +
			 "accepted, but it failed to complete due to " +
			 "an error querying the database.");
      out.println(e);
      return;
    }
  } // end outer else
 }//end doPost's method 
}//end UserLogin's class


